// MyDocument.m

#import "MyDocument.h"

@implementation MyDocument

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    
    if (hostname == nil) {
        [self runMyPanel:nil];
    }

    // Add any code here that need to be executed once the windowController has loaded the document's window.
    //myWindow = [aController window];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    return YES;
}


- (id)init 
{
    config = [NSMutableDictionary alloc];
    [config init];
    return self;
}

- (void)populatePanel
{
    if (hostname != nil) {
        [hostCell setStringValue:hostname];
    } else {
        [hostCell setStringValue:@""];
    }
    if (port != 0) {
        [portCell setIntValue:port];
    } else {
        [portCell setStringValue:@""];
    }
}


- (BOOL)writeToFile:(NSString *)fileName ofType:(NSString *)type
{
    return [config writeToFile: fileName atomically:YES];
}    

- (BOOL)readFromFile:(NSString *)fileName ofType:(NSString *)type
{
    NSDictionary *d;
    NSString *s;

    d = [NSDictionary dictionaryWithContentsOfFile: fileName];
    if (d == nil) {
        return NO;
    }
    [config release];
    config = [d mutableCopy];
    [config retain];
    hostname = [config objectForKey:@"hostname"];
    [hostname retain];

    s = [config objectForKey:@"port"];
    if (s != nil) {
        port = [s intValue];
        [portCell setIntValue:port];
    } else {
        port = 0;
    }
    [self populatePanel];
    return YES;
}


- (IBAction)runMyPanel:(id)sender
{
//NSModalSession session = [NSApp beginModalSessionForWindow:thePanel];

    //[inputArea setAlignment: NSLeftTextAlignment];
#if 1
    int modalValue;
    
    [self populatePanel];
    
    [NSApp beginSheet: thePanel modalForWindow: myWindow modalDelegate: self didEndSelector: NULL contextInfo: 0];
    modalValue = [NSApp runModalForWindow: thePanel];
    if (modalValue == 1) {
     [NSApp endSheet: thePanel];
    [thePanel orderOut: nil];

        [self close];
        return;
    }
       
    if (modalValue == 0 || modalValue == 2) {
        NSLog(@"true");
        [hostname release];
        hostname = [hostCell stringValue];
        [hostname retain];
        
        port = [portCell intValue];
        
        [config setObject:hostname forKey:@"hostname"];
        [config setObject:[portCell stringValue] forKey:@"port"];
    } else {
        NSLog(@"false");
        [self close];
    }

    NSLog(@"hostname");
    NSLog([hostCell stringValue]);
    NSLog([portCell stringValue]);
 [NSApp endSheet: thePanel];
    [thePanel orderOut: nil];

    if (modalValue == 0) {
        [self openConnection:nil];
    }
    //for (;;) {
    //if ([NSApp runModalSession:session] != NSRunContinuesResponse)
       // break;
//}
//[NSApp endModalSession:session];
#endif
}

- (IBAction)endMyModal:(NSButton *)sender
{
    [NSApp stopModalWithCode:[sender tag]];
}

- (IBAction)cancelMyModal:(id)sender
{
    [NSApp stopModalWithCode:0];
}


- (void)echoLine:(NSString *)str 
{
    unsigned int len = [[scrollback string] length];
    NSRange nr = NSMakeRange(len, 0);
        
    [scrollback replaceCharactersInRange: nr withString: @"\n"];
    [scrollback replaceCharactersInRange: nr withString: str];
    [myWindow selectNextKeyView: self];
    
    nr = NSMakeRange([[scrollback string] length] - 1, 0);
    [scrollback scrollRangeToVisible: nr];
    //    [scrollback insertText: @"Hello, world!\n"];
}

- (IBAction)lineEntered:(id)sender
{
    [self echoLine: [inputArea stringValue]];
    [socket writeString:[inputArea stringValue]];
    [socket writeString:@"\r\n"];
}

- (IBAction)openConnection:(id)sender
{
    printf("hello, world\n");
    socket = [Socket socket];
    [socket retain];
    //[socket connectToHostName:@"waterpoint.moo.mud.org" port:8301];
    [socket connectToHostName:hostname port:port];
    [socket setBlocking: false];
    [socket notifyWhenReady:self withSel:@selector(activity)];
    //[socket writeString:@"help\n"];
}

- (void)activity
{
    NSMutableData *md;
    NSString *s;
    //BOOL terminated;
    NSArray *lines;
    
    int count;
    int i;
    
    if (![socket isConnected]) {
        return;
    }
    
    md = [NSMutableData dataWithCapacity: 4096];
    //printf("ready\n");
    count = [socket readData:md];
    //write(2, [md mutableBytes], count);
    
    s = [NSString stringWithCString: [md mutableBytes] length: count];
    if (lineFragment != nil) {
        s = [lineFragment stringByAppendingString: s];
        [lineFragment release];
    }
    
    //terminated = [s hasSuffix:@"\r\n"];
    
    lines = [s componentsSeparatedByString:@"\r\n"];
    
    for (i = 0; i < [lines count] - 1; i++) {
        NSString *line = [lines objectAtIndex: i];
        [self echoLine: line];
    }
    
    if ([lines count]) {
        lineFragment = [lines objectAtIndex: i];
        [lineFragment retain];
    };
    
    //[self echoLine:s];
    
}

- (NSString *)displayName
{
    if ([self fileName] == nil && hostname != nil) {
        NSString *s;
        s = [hostname stringByAppendingFormat:@" - %d", port]; 
        return s;
    } else {
        return [super displayName];
    }
}

- (void)windowWillClose:(NSNotification *)aNotification
{
    if ([socket isConnected]) {
        [socket close];
    }
}
@end
